/** Permette di creare un oggetto "anno" e di sapere il giorno e il mese
    in cui cade la Pasqua */
public class Year  {
  /** Costruisce un oggetto relativo a un anno e intanto calcola il giorno e il
      mese della Pasqua
      @param aYear l'anno in questione
      */
  public Year(int aYear) {
    year = aYear;
    // Utilizza un algoritmo ideato da Gauss
    // Calcolo il giorno e il mese una volta per tutte all'inizio
    // Non rendo l'anno year modificabile
    int a = year % 19;
    int b = year / 100;
    int c = year % 100;
    int d = b / 4;
    int e = b % 4;
    int g = (8 * b + 13) / 25;
    int h = (19 * a + b - d - g + 15) % 30;
    int j = c / 4;
    int k = c % 4;
    int m = (a + 11 * h) / 319;
    int r = (2 * e + 2 * j - k - h + m + 32) % 7;
    easterMonth = (h - m + r + 90) / 25;
    easterDay = (h - m + r + easterMonth + 19) % 32;
  }

  /** Restituisce il giorno della domenica di Pasqua */
  public int getEasterDay() {
    return easterDay;
  }

  /** Restituisce il mese in cui cade la Pasqua */
  public int getEasterMonth() {
    return easterMonth;
  }

  /** Restituisce l'anno */
  public int getYear() {
    return year;
    }
  
  private int easterMonth;

  private int easterDay;

  private int year;
}
